#version 430 core
/*
* Shader for generating depth map for shadow mapping
*/

layout (triangles) in;
layout (triangle_strip, max_vertices=18) out;

uniform mat4 pointLightSpaceMatrices[6];
uniform int type;

out vec4 FragPos; // FragPos from GS (output per emitvertex)

void main()
{
	//we only need to do this if we are using a point light
	if (type == 1) {
		for(int face = 0; face < 6; face++)
    {
        gl_Layer = face; // built-in variable that specifies to which face we render.
        for(int i = 0; i < 3; i++) // for each triangle vertex
        {
            FragPos = gl_in[i].gl_Position;
            gl_Position = pointLightSpaceMatrices[face] * FragPos;
            EmitVertex();
        }    
        EndPrimitive();
    }
	} else {
        for (int i = 0; i < gl_in.length(); i++)
        {
            gl_Position = gl_in[i].gl_Position;
            EmitVertex();
        }
    }
    
}  