#version 430 core

layout(location = 0) in vec3 vertex;
layout(location = 1) in vec4 position;
layout(location = 2) in vec4 col;

out vec4 color;
uniform mat4 viewProjMatrix;
uniform vec3 camUp;
uniform vec3 camRight;

void main() {	
    color = col;

    vec3 pos = position.xyz + camRight * vertex.x * position.w
		+ camUp * vertex.y * position.w;		

	gl_Position = viewProjMatrix * vec4(pos, 1.0);
}